//**********************************************************************************
//                                                                                  
//        _   _       _        ___  ___      _        ___  ___          _             
//       | | | |     | |       |  \/  |     | |       |  \/  |         | |            
//       | |_| | ___ | |_   _  | .  . | ___ | |_   _  | .  . | ___   __| |___       
//       |  _  |/ _ \| | | | | | |\/| |/ _ \| | | | | | |\/| |/ _ \ / _` / __|      
//       | | | | (_) | | |_| | | |  | | (_) | | |_| | | |  | | (_) | (_| \__ \      
//       \_| |_/\___/|_|\__, | \_|  |_/\___/|_|\__, | \_|  |_/\___/ \__,_|___/      
//                       __/ |                  __/ |                               
//                      |___/                  |___/                                
//                                                                                  
//                       Website: http://www.holymolymods.com                       
//*********************************************************************************
// Coded for Openwarfare Mod June 10/2012 by [105]HolyMoly
// V.2.1 Final

#include common_scripts\utility;
#include maps\mp\_utility;
#include maps\mp\gametypes\_hud_util;
#include openwarfare\_utils;

init()
{
        // Precache Shaders
        precacheShader( "juggernaut_goggles_overlay" );
	precacheShader( "waypoint_jugg" );
	precacheShader( "juggernaut_kill" );
	precacheShader( "juggernaut_defend" );
        precacheShader( "hudStopwatch" );

        // Precache Juggernaut Model and View Hands
        precacheModel( "playermodel_mw3_exp_juggernaunt" );
        precacheModel( "viewhands_mw3_op_jugg" );

}

giveJugg()
{
	level endon( "game_ended" );
        self endon("disconnect");

        //Current weapons, ammo, and perks
        self.jnHPammoClipList = [];
        self.jnHPammoStockList = [];
        self.jnHPoriginalHealth = self.health;
        self.jnHPmodel = self.model;

        self.jnHPPerk0 = self.specialty[0];
        self.jnHPPerk1 = self.specialty[1];
        self.jnHPPerk2 = self.specialty[2];

        self.jnHPweaponsList = self getWeaponsList();
      
        for (i = 0; i < self.jnHPweaponsList.size; i++)
        {

                  self.jnHPammoClipList[self.jnHPammoClipList.size] = self getWeaponAmmoClip( self.jnHPweaponsList[i] );
                  self.jnHPammoStockList[self.jnHPammoStockList.size] = self getWeaponAmmoStock( self.jnHPweaponsList[i] );

        }

        self.ishpJuggernaut = true;
        level.hpJuggernaut = true;
        self.isJuggernaut = true;

        if( level.scr_hardpoint_jugg_timer >=1 ) 
                self thread timers();

        self thread onPlayerDeath();
        self thread onJoinedSpectators();
        self thread onGameEnded();
      
	// Juggernaut goggles
	if ( !isDefined( self.jugg_goggles ) ) {
		self.jugg_goggles = newClientHudElem( self );
		self.jugg_goggles.x = 0;
		self.jugg_goggles.y = 0;
		self.jugg_goggles.alignX = "left";
		self.jugg_goggles.alignY = "top";
		self.jugg_goggles.horzAlign = "fullscreen";
		self.jugg_goggles.vertAlign = "fullscreen";
		self.jugg_goggles.sort = -5;
		self.jugg_goggles.color = (0,0,0);
		self.jugg_goggles.archived = false;
		self.jugg_goggles setShader( "juggernaut_goggles_overlay", 640, 480 );	
		self.jugg_goggles.alpha = 0;
	}
	
	// Change to Jug Model
	self detachHead();
	self setModel( "playermodel_mw3_exp_juggernaunt" );
	self setViewModel( "viewhands_mw3_op_jugg" );

        // Third person fix
        if( level.scr_thirdperson_enable == 0 ) 
                self.jugg_goggles.alpha = 1;

	// Verify weapons and remove anyone considered invalid, prevent pickup of invalid weapons
	if( level.scr_hardpoint_jugg_special_loadout == 1 ) {

                 self thread removeInvalidWeapons();
                 self thread preventInvalidWeaponsPickup();
        }
	
        // Mark the JUG player Kill
	objCompassKill = maps\mp\gametypes\_gameobjects::getNextObjID();
	if ( objCompassKill != -1 ) {
		objective_add( objCompassKill, "active", self.origin + ( 0, 0, 105 ) );
		objective_icon( objCompassKill, "juggernaut_kill" );
		objective_onentity( objCompassKill, self );
                if( level.teambased ) objective_team( objCompassKill, level.otherTeam[ self.pers["team"] ] );
             	
	}
       
	// Set stuff for world icon Kill
        if( level.teambased)
                objWorldKill = newTeamHudElem( level.otherTeam[ self.pers["team"] ] );
        else
                objWorldKill = newHudElem();

	origin = self.origin + ( 0, 0, 105 );
	objWorldKill.name = self getEntityNumber();
	objWorldKill.x = origin[0];
	objWorldKill.y = origin[1];
	objWorldKill.z = origin[2];
	objWorldKill.baseAlpha = 1.0;
	objWorldKill.isFlashing = false;
	objWorldKill.isShown = true;
	objWorldKill setShader( "juggernaut_kill", level.objPointSize, level.objPointSize );
	objWorldKill setWayPoint( true, "juggernaut_kill" );
	objWorldKill setTargetEnt( self );
	objWorldKill thread maps\mp\gametypes\_objpoints::startFlashing();
	
	// Start the thread to delete the objective once the Jugg dies or disconnects
	self thread deleteObjectiveKill( objCompassKill, objWorldKill );

        // Mark the Jugg Defend
        if( level.teamBased ) {

                // Mark the JUG player 
	        objCompassDefend = maps\mp\gametypes\_gameobjects::getNextObjID();
	        if ( objCompassDefend != -1 ) {
		        objective_add( objCompassDefend, "active", self.origin + ( 0, 0, 105 ) );
		        objective_icon( objCompassDefend, "juggernaut_defend" );
                        objective_onentity( objCompassDefend, self );
                        objective_team( objCompassDefend, self.pers["team"] );
             	
	        }
       
	        // Set stuff for world icon Defend
                objWorldDefend = newTeamHudElem( self.pers["team"] );
	        origin = self.origin + ( 0, 0, 105 );
	        objWorldDefend.name = self getEntityNumber();
	        objWorldDefend.x = origin[0];
	        objWorldDefend.y = origin[1];
	        objWorldDefend.z = origin[2];
	        objWorldDefend.baseAlpha = 1.0;
	        objWorldDefend.isFlashing = false;
	        objWorldDefend.isShown = true;
	        objWorldDefend setShader( "juggernaut_defend", level.objPointSize, level.objPointSize );
	        objWorldDefend setWayPoint( true, "juggernaut_defend" );
	        objWorldDefend setTargetEnt( self );
	        objWorldDefend thread maps\mp\gametypes\_objpoints::startFlashing();
	
	        // Start the thread to delete the objective once the Jugg dies or disconnects
	        self thread deleteObjectiveDefend( objCompassDefend, objWorldDefend );

        }

        // Breathing Sounds
        self thread juggSounds();
	
	// Set speed  
	self thread openwarfare\_speedcontrol::setBaseSpeed( getdvarx( "class_specops_movespeed", "float", level.scr_hardpoint_jugg_speed, 0.5, 1.5 ) );

        // Set health
	self.maxhealth = getDvarInt( "scr_player_maxhealth" ) * level.scr_hardpoint_jugg_health_multiplier;
	self.health = getDvarInt( "scr_player_maxhealth" ) * level.scr_hardpoint_jugg_health_multiplier;
       
        // Debug
        // iprintln( self.health );

        // Show healthbar
        if( level.scr_hardpoint_jugg_show_healthbar == 1 ) 
                self setClientDvar( "cg_drawhealth", 1 );

        // Show enemy ping
        if( level.scr_hardpoint_jugg_show_enemyping == 1 ) 
                self setClientDvar( "g_compassshowenemies", "1" );

        // Log the event
	lpselfnum = self getEntityNumber();
	lpGuid = self getGuid();
	logPrint("HPJN;" + lpGuid + ";" + lpselfnum + ";" + self.name + "\n");
        // HPJN = Hardpoint Juggernaut

}

returnPlayerOriginal()
{

        self.ishpJuggernaut = false;
        level.hpJuggernaut = undefined;
        self.isJuggernaut = false;

        model = self.jnHPModel;

	// Change to Original Model
	self detachHead();
	self setModel( model );
	self setViewHands( model );
        self setHeadModel( model );

        self thread resetWeapons();

        // Set health
	self.maxhealth = getDvarInt( "scr_player_maxhealth" ); 
	self.health = getDvarInt( "scr_player_maxhealth" );

        self.health = self.jnHPoriginalHealth;

        // Debug
        // iprintln( self.health );

        // Reset
        if( level.scr_hardpoint_jugg_show_healthbar == 1 && level.scr_healthsystem_show_healthbar == 0 ) 
                self setClientDvar( "cg_drawhealth", 0 );

        if( level.scr_hardpoint_jugg_show_enemyping == 1 && level.scr_game_forceuav == 0 ) 
                self setClientDvar( "g_compassshowenemies", "0" );

        // Destroy Shaders
        if( isDefined( self.jugg_goggles ) ) {
                self.jugg_goggles destroy();
        }

        if( isDefined( self.hardpoint_jugg_timer ) ) {
                self.hardpoint_jugg_timer destroy();
        }
                            
        if( isDefined( self.hardpoint_jugg_timer2 ) ) {
                self.hardpoint_jugg_timer2 destroy();
        }


}

onPlayerDeath()
{

        self endon( "jnhardpoint_over" );

        self waittill( "death");

        self.ishpJuggernaut = false;
        level.hpJuggernaut = undefined;
        self.isJuggernaut = false;

        // Reset
        if( level.scr_hardpoint_jugg_show_healthbar == 1 && level.scr_healthsystem_show_healthbar == 0 )   
                self setClientDvar( "cg_drawhealth", 0 );
   
        if( level.scr_hardpoint_jugg_show_enemyping == 1 && level.scr_game_forceuav == 0 ) 
                self setClientDvar( "g_compassshowenemies", "0" );

        // Destroy Shaders
        if( isDefined( self.jugg_goggles ) ) {
                self.jugg_goggles destroy();
        }

        if( isDefined( self.hardpoint_jugg_timer ) ) {
                self.hardpoint_jugg_timer destroy();
        }
                            
        if( isDefined( self.hardpoint_jugg_timer2 ) ) {
                self.hardpoint_jugg_timer2 destroy();
        }

        self notify( "jnhardpoint_over" );


}

onJoinedSpectators()
{

        self endon( "jnhardpoint_over" );

        self waittill( "joined_spectators" );

        self.ishpJuggernaut = false;
        self.isJuggernaut = false;
        level.hpJuggernaut = undefined;

        // Reset
        if( level.scr_hardpoint_jugg_show_healthbar == 1 && level.scr_healthsystem_show_healthbar == 0 ) 
                self setClientDvar( "cg_drawhealth", 0 );

        if( level.scr_hardpoint_jugg_show_enemyping == 1 && level.scr_game_forceuav == 0 ) 
                self setClientDvar( "g_compassshowenemies", "0" );

        // Destroy Shaders
        if( isDefined( self.jugg_goggles ) ) {
                self.jugg_goggles destroy();
        }

        if( isDefined( self.hardpoint_jugg_timer ) ) {
                self.hardpoint_jugg_timer destroy();
        }
                            
        if( isDefined( self.hardpoint_jugg_timer2 ) ) {
                self.hardpoint_jugg_timer2 destroy();
        }

        self notify( "jnhardpoint_over" );

}

onGameEnded()
{

	self endon( "disconnect" );
	self endon( "death" );
        self endon( "jnhardpoint_over" );

	level waittill( "game_ended" );

        self.ishpJuggernaut = false;
        self.isJuggernaut = false;
        level.hpJuggernaut = undefined;

        // Reset
        if( level.scr_hardpoint_jugg_show_healthbar == 1 && level.scr_healthsystem_show_healthbar == 0 ) 
                self setClientDvar( "cg_drawhealth", 0 );

        if( level.scr_hardpoint_jugg_show_enemyping == 1 && level.scr_game_forceuav == 0 ) 
                self setClientDvar( "g_compassshowenemies", "0" );

        // Destroy Shaders
        if( isDefined( self.jugg_goggles ) ) {
                self.jugg_goggles destroy();
        }

        if( isDefined( self.hardpoint_jugg_timer ) ) {
                self.hardpoint_jugg_timer destroy();
        }
                            
        if( isDefined( self.hardpoint_jugg_timer2 ) ) {
                self.hardpoint_jugg_timer2 destroy();
        }

        self notify( "jnhardpoint_over" );

}

timers()
{
        self endon( "death" );
        self endon( "disconnect" );
	level endon( "game_ended" );

	if( !isDefined( self.hardpoint_jugg_timer ) ){
	      self.hardpoint_jugg_timer = newClientHudElem(self);
	      self.hardpoint_jugg_timer.x = 200;
	      self.hardpoint_jugg_timer.y = 445;
	      self.hardpoint_jugg_timer.alignx = "center";
	      self.hardpoint_jugg_timer.aligny = "middle";
	      self.hardpoint_jugg_timer.horzAlign = "fullscreen";
	      self.hardpoint_jugg_timer.vertAlign = "fullscreen";
	      self.hardpoint_jugg_timer.alpha = 0;
	      self.hardpoint_jugg_timer.fontScale = 2;
	      self.hardpoint_jugg_timer.sort = 100;
	      self.hardpoint_jugg_timer.glowColor = ( 0.2, 0.3, 0.7 );
	      self.hardpoint_jugg_timer.glowAlpha = 0;
	      self.hardpoint_jugg_timer.foreground = true;
              self.hardpoint_jugg_timer setClock( level.scr_hardpoint_jugg_timer_set, 60, "hudStopwatch", 60, 60 ); // time, dial size, shader name, xdim, ydim
	    
	}

        if( !isDefined( self.hardpoint_jugg_timer2 ) ){
	      self.hardpoint_jugg_timer2 = newClientHudElem(self);
	      self.hardpoint_jugg_timer2.x = 188;
              self.hardpoint_jugg_timer2.y = 460;
	      self.hardpoint_jugg_timer2.alignX = "center";
	      self.hardpoint_jugg_timer2.alignY = "middle";
	      self.hardpoint_jugg_timer2.horzAlign = "fullscreen";
	      self.hardpoint_jugg_timer2.vertAlign = "fullscreen";
	      self.hardpoint_jugg_timer2.fontScale = 1.6;
	      self.hardpoint_jugg_timer2.sort = 100;
	      self.hardpoint_jugg_timer2.foreground = true;
	      self.hardpoint_jugg_timer2.glowColor = ( 0.2, 0.3, 0.7 );
	      self.hardpoint_jugg_timer2.glowAlpha = 0;
              self.hardpoint_jugg_timer2.alpha = 0;
              self.hardpoint_jugg_timer2 setTenthsTimer( level.scr_hardpoint_jugg_timer_set );

	}

        // Show the timer
        if( level.scr_hardpoint_jugg_timer == 1 ){
                self.hardpoint_jugg_timer.alpha = .9;
                self thread timerColor();
        }

        // Show the timer2
        if( level.scr_hardpoint_jugg_timer == 2 ){
                self.hardpoint_jugg_timer2.alpha = .9;
                self thread timerColor();
        }

        wait ( level.scr_hardpoint_jugg_timer_set );

        self notify( "jnhardpoint_over" );

        self thread returnPlayerOriginal();

}

removeInvalidWeapons()
{

        self endon("death");
        self endon("disconnect");

        while( isDefined( self.throwingGrenade ) && self.throwingGrenade == true ) {
                wait( 0.05 );
        }

	jugWeapon = "";
        secondaryWeapon = "";

	// Remove all weapons and perks from the Jugg
	self thread maps\mp\gametypes\_gameobjects::_disableWeapon();
	self takeAllWeapons();
	self clearPerks();

	// Give the Jugg fixed specialties
	self.specialty = [];
	self.specialty[0] = level.scr_hardpoint_jugg_specialty_slot0;
	        if ( self.specialty[0] != "specialty_null" )
		     self setPerk( self.specialty[0] );
		
	self.specialty[1] = level.scr_hardpoint_jugg_specialty_slot1;
	        if ( self.specialty[1] != "specialty_null" )
		     self setPerk( self.specialty[1] );
	
	self.specialty[2] = level.scr_hardpoint_jugg_specialty_slot2;
	        if ( self.specialty[2] != "specialty_null" )
		     self setPerk( self.specialty[2] );
		
        // Check if the Jugg has no weapon, then force default
	        if ( level.scr_hardpoint_force_jugweapon != "" ) {
		     jugWeapon = level.scr_hardpoint_force_jugweapon;

                }
         		
	// Check if the Jugg has secondary weapon 
	        if ( level.scr_hardpoint_jugweapon_secondary != "" ) {
		     secondaryWeapon = level.scr_hardpoint_jugweapon_secondary; 

                     // Give secondary weapon
                     self giveWeapon( secondaryWeapon );
	             self giveMaxAmmo( secondaryWeapon );
	             self thread giveActionSlot3AfterDelay( secondaryWeapon );
	             self setActionSlot( 4, "" ); 

                }

	// Give maximum amount of ammo for Jugg weapon and switch to it
	self giveWeapon( jugWeapon );
	self giveMaxAmmo( jugWeapon );
	self setSpawnWeapon( jugWeapon );

        // Fix animation if throwing
        wait( 0.20 );

	self switchToWeapon( jugWeapon );
   
	// Enable the Jugg weapon
	self thread maps\mp\gametypes\_gameobjects::_enableWeapon();

        //Give nades 
        if ( level.scr_hardpoint_jugg_nades == 1 ) {
                self switchToOffhand( "frag_grenade_mp" );
		self giveWeapon( "frag_grenade_mp" );
		self setWeaponAmmoClip( "frag_grenade_mp", level.scr_hardpoint_jugg_nades_amount );
        }

        // Show Perks on spawn
	if ( level.scr_hardpoint_jugg_show_perks_on_spawn == 1 )
	{
		perks = getPerks( self );
		self showPerk( 0, perks[0], -50 );
		self showPerk( 1, perks[1], -50 );
		self showPerk( 2, perks[2], -50 );
		self thread hidePerksAfterTime( 3.0 );
		self thread hidePerksOnDeath();
	}

} 

preventInvalidWeaponsPickup()
{

        self endon( "death" );
        self endon( "disconnect" );
        self endon( "jnhardpoint_over" );

   
        for (;;)
        {
                wait (0.05);
                currentWeapon = self getCurrentWeapon();
      
                // Allow use of hardpoint weapons and Juggernaut weapons Only
                if( currentWeapon != level.scr_hardpoint_force_jugweapon && currentWeapon != level.scr_hardpoint_jugweapon_secondary && currentWeapon != "radar_mp" && currentWeapon != "airstrike_mp" && currentWeapon != "helicopter_mp" && currentWeapon != "juggernaut_mp" ) {
                        self dropItem( currentWeapon );
 	
                        // Check if the player has Jugg weapon and automatically switch to it
                        weaponsList = self getWeaponsList();
                        for( i = 0; i < weaponsList.size; i++ )	{
	                        if ( weaponsList[i] == level.scr_hardpoint_force_jugweapon || weaponsList[i] == level.scr_hardpoint_jugweapon_secondary ) {
		                        self switchToWeapon( weaponsList[i] );
			                break;
	                        }

                        }

                }

        }

}

deleteObjectiveKill( objID, objWorldKill )
{
	self waittill_any( "killed_player", "disconnect", "jnhardpoint_over" );

	// Stop flashing Kill icon
	objWorldKill notify("stop_flashing_thread");
	objWorldKill thread maps\mp\gametypes\_objpoints::stopFlashing();

	// Wait some time to make sure the main loop ends	
	wait (0.25);
	
	// Delete the objective
	if ( objID != -1 ) {
		objective_delete( objID );
		maps\mp\gametypes\_gameobjects::resetObjID( objID );
	}

	objWorldKill destroy();
	
}

deleteObjectiveDefend( objID, objWorldDefend )
{
	self waittill_any( "killed_player", "disconnect", "jnhardpoint_over" );

	// Stop flashing Kill icon
	objWorldDefend notify("stop_flashing_thread");
	objWorldDefend thread maps\mp\gametypes\_objpoints::stopFlashing();

	// Wait some time to make sure the main loop ends	
	wait (0.25);
	
	// Delete the objective
	if ( objID != -1 ) {
		objective_delete( objID );
		maps\mp\gametypes\_gameobjects::resetObjID( objID );
	}

	objWorldDefend destroy();
	
}

detachHead()
{
	// Get all the attached models from the player
	attachedModels = self getAttachSize();
	
	// Check which one is the head and detach it
	for ( am=0; am < attachedModels; am++ ) {
		thisModel = self getAttachModelName( am );
		
		// Check if this one is the head and remove it
		if ( isSubstr( thisModel, "head_mp_" ) ) {
			self detach( thisModel, "" );
			break;
		}		
	}
	
	return;
}

hidePerksAfterTime( delay )
{
	self endon("disconnect");
	self endon("perks_hidden");

	wait delay;

	self thread hidePerk( 0, 2.0 );
	self thread hidePerk( 1, 2.0 );
	self thread hidePerk( 2, 2.0 );
	self notify("perks_hidden");
}

hidePerksOnDeath()
{
	self endon("disconnect");
	self endon("perks_hidden");

	self waittill("death");

	self hidePerk( 0 );
	self hidePerk( 1 );
	self hidePerk( 2 );
	self notify("perks_hidden");
}

getPerks( player )
{
	perks[0] = "specialty_null";
	perks[1] = "specialty_null";
	perks[2] = "specialty_null";
	
	if ( isPlayer( player ) && !level.oldschool )
	{
		if ( isDefined( player.specialty[0] ) )
			perks[0] = player.specialty[0];
		if ( isDefined( player.specialty[1] ) )
			perks[1] = player.specialty[1];
		if ( isDefined( player.specialty[2] ) )
			perks[2] = player.specialty[2];
	}
	
	return perks;
}

timerColor()
{

	level endon( "game_ended" );
	self endon( "death" );
        self endon("disconnect");
        self endon( "jnhardpoint_over" );

        timeLeft = int( level.scr_hardpoint_jugg_timer_set );

        while( true )
        {

                if( timeLeft <= 10 )
                { 
                     if( level.scr_hardpoint_jugg_timer_color == 1 ){
                              self.hardpoint_jugg_timer2.color = ( 1, 0, 0 );// Red
                              self.hardpoint_jugg_timer.color = ( 1, 0, 0 );
                     }

                     if( timeLeft == 0 ) break; // No tick on second "0" :)
                     self playLocalSound( "ui_mp_suitcasebomb_timer" );

                }else if( timeLeft <= 20 ){

                     if( level.scr_hardpoint_jugg_timer_color == 1 ){
                              self.hardpoint_jugg_timer2.color = ( 1, 0.5, 0 );// Orange
                              self.hardpoint_jugg_timer.color = ( 1, 0.5, 0 );
                     }
 
                }else if( timeLeft > 20 ){

                     if( level.scr_hardpoint_jugg_timer_color == 1 ){
                             self.hardpoint_jugg_timer2.color = ( 0, 1, 0 ); //Green
                             self.hardpoint_jugg_timer.color = ( 0, 1, 0 );
                     }
                }

                wait ( 1.0 );
                timeLeft--;
            
         }

}

resetWeapons()
{

        useAltMode = true;
        class = self.class;

        while( isDefined( self.throwingGrenade ) && self.throwingGrenade == true ) {
                wait( 0.05 );
        }

	// Remove all weapons 
	self thread maps\mp\gametypes\_gameobjects::_disableWeapon();
	self takeAllWeapons();

	// Make sure the player gets any hardpoint that he/she already had
	if ( isDefined( self.pers["hardPointItem"] ) ) {
		self maps\mp\gametypes\_hardpoints::giveHardpointItem( self.pers["hardPointItem"] );
	}

        self clearPerks();

	// Give Perks back
	self.specialty = [];
        self.specialty[0] = self.jnHPPerk0;
        if( self.specialty[0] == "c4_mp" || self.specialty[0] == "claymore_mp" || self.specialty[0] == "rpg_mp" ) {
                    self.specialty[0] = "specialty_null";
        }
	if ( isDefined( self.specialty[0] ) && self.specialty[0] != "specialty_null" )
		    self setPerk( self.specialty[0] );

	self.specialty[1] = self.jnHPPerk1;
	if ( isDefined( self.specialty[1] ) && self.specialty[1] != "specialty_null" )
		    self setPerk( self.specialty[1] );
	
	self.specialty[2] = self.jnHPPerk2;
	if ( isDefined( self.specialty[2] ) && self.specialty[2] != "specialty_null" )
		    self setPerk( self.specialty[2] );
    
        for( i = 0; i < self.jnHPweaponsList.size; i++ )
        {
             if( !isDefined( self.camo_num ) ) 
                     self.camo_num = 0;

             self giveWeapon( self.jnHPweaponsList[i], self.camo_num );
          
             //Set primary weapon 
             if ( isPrimaryWeapon( self.jnHPweaponsList[i] ) && WeaponType( self.jnHPweaponsList[i] ) == "bullet" )
             {
                  self setSpawnWeapon( self.jnHPweaponsList[i] );
             }
      
             switch ( self.jnHPweaponsList[i] ) //Set offhand setttings
             {
                  case "frag_grenade_mp":
                              self switchToOffhand( "frag_grenade_mp" );
                              break;

                  case "flash_grenade_mp":
                              self setOffhandSecondaryClass( "flash" );
                              break;

                  case "smoke_grenade_mp":
                  case "concussion_grenade_mp":
                              self setOffhandSecondaryClass( "smoke" );
                              break;

             }
   
             switch ( self.jnHPweaponsList[i] ) //Setup ammo sizes and action slots 3,4
             {
                  case "claymore_mp":
                  case "rpg_mp":
                  case "c4_mp":

                              if ( level.rankedMatch )
                                      self maps\mp\gametypes\_class::setWeaponAmmoOverall( self.jnHPweaponsList[i], self.jnHPammoClipList[i] );
                              else
                                      self maps\mp\gametypes\_class_unranked::setWeaponAmmoOverall( self.jnHPweaponsList[i], self.jnHPammoClipList[i] );

                              self setActionSlot( 3, "weapon", self.jnHPweaponsList[i] );
                              self setActionSlot( 4, "" );
                              useAltMode = false;
                              break;
                  default:
                              self setWeaponAmmoClip( self.jnHPweaponsList[i], self.jnHPammoClipList[i] );
                              self setWeaponAmmoStock( self.jnHPweaponsList[i], self.jnHPammoStockList[i] );
                              break;
             }

        }

        // Set Class Speed
	switch ( class )
	{
		case "assault":
			self thread openwarfare\_speedcontrol::setBaseSpeed( getdvarx( "class_assault_movespeed", "float", 0.95, 0.5, 1.5 ) );
			break;
		case "specops":
			self thread openwarfare\_speedcontrol::setBaseSpeed( getdvarx( "class_specops_movespeed", "float", 1.0, 0.5, 1.5 ) );
			break;
		case "heavygunner":
			self thread openwarfare\_speedcontrol::setBaseSpeed( getdvarx( "class_heavygunner_movespeed", "float", 0.875, 0.5, 1.5 ) );
			break;
		case "demolitions":
			self thread openwarfare\_speedcontrol::setBaseSpeed( getdvarx( "class_demolitions_movespeed", "float", 1.0, 0.5, 1.5 ) );
			break;
		case "sniper":
			self thread openwarfare\_speedcontrol::setBaseSpeed( getdvarx( "class_sniper_movespeed", "float", 1.0, 0.5, 1.5 ) );
			break;
		default:
			self thread openwarfare\_speedcontrol::setBaseSpeed( 1.0 );
			break;
	}

        if ( useAltMode ) //Set to altmode if alt. weapon is not claymore, rpg, or c4
        {
                 self setActionSlot( 3, "altMode" );
                 self setActionSlot( 4, "" );
        }

        // cac specialties that require loop threads
        if ( level.rankedMatch )

                 self maps\mp\gametypes\_class::cac_selector();
        else
                 self maps\mp\gametypes\_class_unranked::cac_selector();

        // Fix animation if throwing
        wait( 0.20 );

	self switchToWeapon( self.jnHPweaponsList[i] );

	// Enable weapons
	self thread maps\mp\gametypes\_gameobjects::_enableWeapon();

        // Show Perks on spawn
	if ( level.scr_hardpoint_jugg_show_perks_on_spawn == 1 )
	{
		perks = getPerks( self );
		self showPerk( 0, perks[0], -50 );
		self showPerk( 1, perks[1], -50 );
		self showPerk( 2, perks[2], -50 );
		self thread hidePerksAfterTime( 3.0 );
		self thread hidePerksOnDeath();
	}

}

setViewHands( model )
{

              switch( model )
              {
                     case "body_mp_arab_regular_assault":
                     case "body_mp_arab_regular_cqb":
                     case "body_mp_arab_regular_engineer":
                     case "body_mp_arab_regular_sniper":
                     case "body_mp_arab_regular_support":
                          self setViewModel( "viewhands_desert_opfor");
                          break;

                     case "body_mp_opforce_assault":
                     case "body_mp_opforce_cqb":
                     case "body_mp_opforce_eningeer":
                     case "body_mp_opforce_support":
                     case "body_mp_opforce_urban_assault":
                     case "body_mp_opforce_urban_cqb":
                     case "body_mp_opforce_urban_engineer":
                     case "body_mp_opforce_urban_sniper":
                     case "body_mp_opforce_urban_support":
                          self setViewModel( "viewhands_op_force");
                          break;

                     case "body_mp_sas_urban_assault":
                     case "body_mp_sas_urban_recon":
                     case "body_mp_sas_urban_sniper":
                     case "body_mp_sas_urban_specops":
                     case "body_mp_sas_urban_support":
                          self setViewModel( "viewhands_black_kit");
                          break;

                     case "body_mp_usmc_assault":
                     case "body_mp_usmc_cqb":
                     case "body_mp_usmc_engineer":
                     case "body_mp_usmc_grenadier":
                     case "body_mp_usmc_recon":
                     case "body_mp_usmc_rifleman":
                     case "body_mp_usmc_sniper":
                     case "body_mp_usmc_specops":
                     case "body_mp_usmc_support":
                          self setViewModel( "viewmodel_base_viewhands");
                          break;

                     case "body_mp_usmc_woodland_assault":
                     case "body_mp_usmc_woodland_recon":
                     case "body_mp_usmc_woodland_specops":
                     case "body_mp_usmc_woodland_support":
                          self setViewModel( "viewhands_sas_woodland");
                          break;

                     case "body_mp_usmc_woodland_sniper":
                     case "body_mp_opforce_sniper":
                          self setViewModel( "viewhands_marine_sniper");
                          break;

                     default:
                          break;
             }

}

setHeadModel( model )
{

              switch( model )
              {
                     case "body_mp_arab_regular_assault":
                           self attach("head_mp_arab_regular_suren", "", true);
                           break;
                     case "body_mp_arab_regular_cqb":
                           self attach("head_mp_arab_regular_headwrap", "", true);
                           break;
                     case "body_mp_arab_regular_engineer":
                           self attach("head_mp_arab_regular_ski_mask", "", true);
                           break;
                     case "body_mp_arab_regular_sniper":
                           self attach("head_mp_arab_regular_sadiq", "", true);
                           break;
                     case "body_mp_arab_regular_support":
                           self attach("head_mp_arab_regular_asad", "", true);
                           break;

                     case "body_mp_opforce_assault":
                     case "body_mp_opforce_urban_assault":
                           self attach("head_mp_opforce_headwrap", "", true);
                           break;
                     case "body_mp_opforce_cqb":
                     case "body_mp_opforce_eningeer":
                     case "body_mp_opforce_urban_cqb":
                     case "body_mp_opforce_urban_engineer":
                           self attach("head_mp_opforce_gasmask", "", true);
                           break;
                     case "body_mp_opforce_sniper":
                           self attach("head_mp_opforce_ghillie", "", true);
                           break;
                     case "body_mp_opforce_support":
                     case "body_mp_opforce_urban_support":
                           self attach("head_mp_opforce_3hole_mask", "", true);
                           break;
                     case "body_mp_opforce_urban_sniper":
                           self attach("head_mp_opforce_justin", "", true);
                           break;

                     case "body_mp_usmc_assault":
                     case "body_mp_usmc_woodland_assault":
                           self attach("head_mp_usmc_tactical_mich", "", true);
                           break;
                     case "body_mp_usmc_recon":
                     case "body_mp_usmc_woodland_recon":
                           self attach("head_mp_usmc_nomex", "", true);
                           break;
                     case "body_mp_usmc_sniper":
                           self attach("head_mp_usmc_tactical_baseball_cap", "", true);
                           break;
                     case "body_mp_usmc_specops":
                     case "body_mp_usmc_woodland_specops":
                           self attach("head_mp_usmc_tactical_mich_stripes_nomex", "", true);
                           break;
                     case "body_mp_usmc_support":
                     case "body_mp_usmc_woodland_support":
                           self attach("head_mp_usmc_shaved_head", "", true);
                           break;
                     case "body_mp_usmc_woodland_sniper":
                           self attach("head_mp_usmc_ghillie", "", true);
                           break;

                     default:
                          break;

             }

}

isPrimaryWeapon( weaponname )
{
        return isdefined( level.primary_weapon_array[weaponname] );
}

juggSounds()
{
	self endon( "death" );
	self endon( "disconnect" );
	self endon( "jnhardpoint_over" );

	for ( ;; )
	{
                wait ( 1.5 );
		self playSound( "jugg_breathing_sound" );
                wait ( 1.5 );

                if( level.gameEnded || level.intermission ) {
                        break;
                }
	}

}
